package businessLayer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import dataLayer.Copia;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCopia;

public class ManipulacaoCopia {
	private RepositorioCopia generico;
	
	public ManipulacaoCopia(RepositorioCopia recebido) {
		generico = recebido;
	}
	
	public void cadastrarCopia(String nome, double codigo, String genero, String tipo) throws IOException
	{
		if(!nome.equals(null) && !genero.equals(null) && codigo!=(0))
		{
			Copia copia = new Copia(nome, codigo, genero, tipo);
			
			// ACHO QUE ESSE CATCH TAMBM NO VAI EXECUTAR.
			
			Iterator<Copia> comparador = generico.getIterator();
			
			boolean passa = true;
			
			while(comparador.hasNext())
			{
				if(((Copia) comparador.next()).getCodigo() == (copia.getCodigo()))
				{
					passa = false;
				}
			}
			
			if(passa)
			{
				generico.inserirCopia(copia);
			}
		}
		else;										// completar com exception.
	}
	
	public List<Copia> visualizarCopia(String nome)
	{
		List<Copia> resposta = new ArrayList<Copia>();					// Cliente de retorno  iniciado;
		Iterator<Copia> novo = generico.getIterator();					// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (Copia) novo.next()).getNome().contains(nome))			// Se um Cliente analizado contiver o nome buscado
			{															// a resposta enviada ser esse prprio Cliente.
				resposta.add((Copia) novo.next());
			}
		}
		return resposta;
		
		/* Obs: o casting para Cpia  necessrio porque o objeto retornado como parmetro  genrico. */
	}
	
	public void removerCopia(double codigo)
	{
		Iterator<Copia> novo = generico.getIterator();				// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (Copia) novo.next()).getCodigo() == codigo)			// Se um Cliente analizado for exatamente igual ao cpf
			{															// indicado o Cliente em questo ser removido do Vector.
				Copia removida = (Copia) novo.next();
				
				// DUVIDO QUE ESSE CATCH EXECUTE!
				
				try {
					this.generico.removerCopia(removida);
				} catch (IOException e) {
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
