package dataLayer;
import java.io.Serializable;
import java.util.Date;

// LEMBRAR QUE O CLIENTE PODE FAZER UMA LOCAO.

public class Cliente implements Serializable{
	
	private static final long serialVersionUID = 42L;
	
	private String cpf;
	private String nome;
	private Date nascimento;
	private Endereco endereco;
	private String telefoneFix;
	private String telefoneCel;
	private String observacao;
	
	public Cliente(String cpf, String nome, Date nascimento, Endereco endereco, String telefoneFix, String telefoneCel, String observacao) {
		this.setCpf(cpf);
		this.setNome(nome);
		this.setNascimento(nascimento);
		this.setEndereco(endereco);
		this.setTelefoneFix(telefoneFix);
		this.setTelefoneCel(telefoneCel);
		this.setObservacao(observacao);
	}

	public void setCpf(String cpf) {
		this.cpf = cpf;
	}
	public String getCpf() {
		return cpf;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getNome() {
		return nome;
	}

	public void setNascimento(Date nascimento) {
		this.nascimento = nascimento;
	}
	public Date getNascimento() {
		return nascimento;
	}

	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}
	public Endereco getEndereco() {
		return endereco;
	}

	public void setTelefoneFix(String telefoneFix) {
		this.telefoneFix = telefoneFix;
	}
	public String getTelefoneFix() {
		return telefoneFix;
	}

	public void setTelefoneCel(String telefoneCel) {
		this.telefoneCel = telefoneCel;
	}
	public String getTelefoneCel() {
		return telefoneCel;
	}

	public void setObservacao(String observacao) {
		this.observacao = observacao;
	}

	public String getObservacao() {
		return observacao;
	}
	
	@SuppressWarnings("deprecation")
	public String toString()
	{
		String birth = nascimento.getDate()+"/"+nascimento.getMonth()+"/"+nascimento.getYear();
		String local = endereco.getLogradouro() + ", " +endereco.getNumero() +", "+ endereco.getComplemento()+", " +endereco.getBairro() +", " + endereco.getCidade() +", " + endereco.getEstado() +", ";
		String resposta = "Cpf: " + this.cpf + "; Nome: " + this.nome + "; Nascimento: "+ birth + "; Endereo: " + local + "Telefones: " + telefoneFix +", " + telefoneCel;
		return resposta;
	}
}
