package dataLayer.Repositorios.Array;

import dataLayer.Copia;
import dataLayer.Iterable;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCopia;

	/* Obs: A classe RepositorioArrayCopia utiliza-se dos mesmos mtodos que a classe RepositorioArrayCliente, diferindo desta
	apenas pelos tipos utilizados nos parmetros. Logo os comentrios tambm seguem as mesmas diretrizes da classe supracitada. */

public class RepositorioArrayCopia implements RepositorioCopia, Iterable<Copia>{
	private Copia[] biblioteca;
	private int indiceB;
	
	public RepositorioArrayCopia()
	{
		this.biblioteca = new Copia[10];
		this.indiceB = 0;
	}
	
	private void duplicarArray()
	{
		Copia[] aux = new Copia[this.biblioteca.length*2];
		
		for(int i = 0; i<this.biblioteca.length; i++)
		{
			aux[i] = this.biblioteca[i];
		}
		
		this.biblioteca = aux;
	}
	
	public void inserirCopia(Copia c)
	{
		if(indiceB < biblioteca.length)
		{
			this.biblioteca[indiceB] = c;
			this.indiceB++;
		}
		else 
		{
			this.duplicarArray();
			this.biblioteca[indiceB] = c;
			this.indiceB++;
		}
	}
	
	public void removerCopia(Copia filme)
	{
		Iterator<Copia> novo = new Iterator<Copia>(biblioteca);	
		while(novo.hasNext())
		{
			if(( (Copia) novo.next()).getCodigo() == filme.getCodigo())
			{
				this.indiceB--;
				Copia aux = biblioteca[indiceB];
				biblioteca[indiceB] = null;
				biblioteca[novo.getIndex()] = aux;
			}
		}
	}
	
//	public Copia visualizarCopia(String nome)
//	{
//		Copia resposta = null;
//		Iterator<Copia> novo = new Iterator<Copia>(biblioteca);	
//		while(novo.hasNext())
//		{
//			if(( (Copia) novo.next()).getNome().contains(nome))
//			{
//				resposta = (Copia) novo.next();
//			}
//		}
//		return resposta;
//	}

	public Iterator<Copia> getIterator()
	{
		Iterator<Copia> resposta = new Iterator<Copia>(biblioteca);
		return resposta;
	}
}
