package dataLayer;
import java.util.ArrayList;
import java.util.List;

public class Iterator <AnyType> {
	/* O iterator  marcado como uma classe que "suportar" um List de qualquer tipo (AnyType), para que possa receber um parmetro
	genrico pelas classes que o utilizaro para a varredura. */ 
	
	private List <AnyType> list;									// List de tipo genrico.
	private int indexExiste;										// ndice para marcar a posio.
	
	private List <AnyType> changeType(AnyType[] obj)				// O conversor de Array para vector  feito para no haver
	{																// necessidade da presena de dois Iterators.
		List <AnyType> resposta = new ArrayList <AnyType>();		// List de resposta iniciado.
		for(int i = 0; i < obj.length; i++)							// Contador l o array e coloca todos os dados no List de resposta.
		{
			resposta.add(obj[i]);
		}
		return resposta;											// Resposta retornada.
	}
	
	public Iterator(List <AnyType> obj)								// Um construtor para o tipo Vector.
	{
		this.list = obj;
		this.indexExiste = -1;
	}
	public Iterator(AnyType[] obj)									// Um construtor para o tipo Array (usar a mudana de tipo).
	{
		this.list = this.changeType(obj);
		this.indexExiste = -1;
	}

	/* Obs: O ndice  marcado inicialmente como -1 para que, ao se verificar inicialmente as presena de um prximo valor ele
	avance para 0 e leia o primeiro valor. Fato necessrio para que o mtodo next() abaixo no necessite de um ndice prprio,
	pois o valor de marcao sempre simbolizar uma posio vlida. */
	
	public boolean hasNext()
	{
		boolean resposta = false;
		this.indexExiste++;
		if(indexExiste < list.size() && list.get(indexExiste) != null)
		{
			resposta = true;
		}
		return resposta;
	}
	
	public Object next()
	{
		Object resposta = list.get(indexExiste);
		return resposta;
	}
	
	public int getIndex()
	{
		return this.indexExiste;
	}
	
	// metodo de testes
	
	public int getSize()
	{
		return this.list.size();
	}
}
