package dataLayer.Repositorios.Vector;

import java.util.Vector;

import dataLayer.Iterable;
import dataLayer.Copia;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCopia;

public class RepositorioVectorCopia implements RepositorioCopia, Iterable<Copia>{
	private Vector <Copia> biblioteca;

	public RepositorioVectorCopia()
	{
		this.biblioteca = new Vector <Copia>();
	}
	
	public void inserirCopia(Copia filme)
	{
		biblioteca.add(filme);
	}
	
	public void removerCopia(Copia filme)
	{
		this.biblioteca.remove(filme);
	}
	
	// MTODOS APENAS PARA CHECAGEM, DELETAR DEPOIS!
	public Vector<Copia> getCopia()
	{
		return this.biblioteca;
	}
	public String visualisadorIndice(int i)
	{
		String retorno = "Nome: " + biblioteca.get(i).getNome() + " | Cdigo: " + biblioteca.get(i).getCodigo() + " | Gnero: " + biblioteca.get(i).getGenero() + " | Tipo: " + biblioteca.get(i).getTipo(); 
		return retorno;
	}
	
//	public Copia visualizarCopia(String nome)
//	{
//		Copia resposta = null;											// Cpia de retorno  iniciada;
//		Iterator<Copia> novo = new Iterator<Copia>(biblioteca);			// Iterator  criado copiando-se os valores do repositrio.
//		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
//		{
//			if(( (Copia) novo.next()).getNome().contains(nome))			// Se um Cpia analizada contiver o nome buscado
//			{															// a resposta enviada ser essa prprio Cpia.
//				resposta = (Copia) novo.next();
//			}
//		}
//		return resposta;
//		
//		/* Obs: o casting para Cpia  necessrio porque o objeto retornado como parmetro  genrico. */
//	}
	
	public Iterator<Copia> getIterator()
	{
		Iterator<Copia> resposta = new Iterator<Copia>(biblioteca);
		return resposta;
	}
}
