package dataLayer.Repositorios.Vector;

import java.util.Vector;

import dataLayer.Iterable;
import dataLayer.Iterator;
import dataLayer.LocacaoIdentidade;
import dataLayer.Repositorios.Interface.RepositorioLocacao;

public class RepositorioVectorLocacao implements RepositorioLocacao, Iterable<LocacaoIdentidade>{
	private Vector <LocacaoIdentidade> registro;
	
	/* O vector aqui  do tipo LocacaoIdentidade (uma classe que possui um atributo que Locacao no possui, a identidade).
	Desta maneira podemos criar um parmetro para julgar de uma locao  nica ou no, marcando-a com um inteiro nico. */

	public RepositorioVectorLocacao()
	{
		this.registro = new Vector <LocacaoIdentidade>();
	}
	
	public void fazerLocacao(LocacaoIdentidade locado)						// O mtodo de fazer uma locao recebe uma locao bsica como parmetro.
	{
		registro.add(locado);
	}
	
	public void cancelarLocacao(LocacaoIdentidade locacao)
	{
		this.registro.remove(locacao);	
	}
	
	public Iterator<LocacaoIdentidade> getIterator() {
		Iterator<LocacaoIdentidade> resposta = new Iterator<LocacaoIdentidade>(registro);
		return resposta;
	}
}
